#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>
#include <sys/time.h>
#include <assert.h>

//Uncomment to use 2-col format
//#define FORMAT_2COL

#ifdef FORMAT_2COL
// these defs are for when we use 2-column format
#define SU3VEC_SIZE 3
#define SU3MAT_COLS 2
#define SU3MAT_SIZE 6

// refer to specific matrix elements in a way that is easy (easier?) on the eye
#define IDX_00 (0)
#define IDX_01 (1)
#define IDX_10 (2)
#define IDX_11 (3)
#define IDX_20 (4)
#define IDX_21 (5)

#define FORMAT_LABEL "2 column"



#else /* regular 3-col format for su(3) matrices*/
#define SU3MAT_SIZE 9
#define SU3VEC_SIZE 3
#define SU3MAT_COLS 3

// refer to specific matrix elements in a way  that is easy on the eye
#define IDX_00 (0)
#define IDX_01 (1)
#define IDX_02 (2)

#define IDX_10 (3)
#define IDX_11 (4)
#define IDX_12 (5)

#define IDX_20 (6)
#define IDX_21 (7)
#define IDX_22 (8)
#define FORMAT_LABEL "3 column"

#endif /* FORMAT_2COL */

#define SU3MAT_FULLSIZE 9  /* always 9 components in reall life */


#define REAL float
#define VWIDTH 64

//#define VOLUME (1024*4)
//#define VOLUME (1024*1024)
//#define VOLUME (8388608)
//#define VOLUME (4194304)
//#define VOLUME (2097152)

//#define VOLUME (1048576)
//#define VOLUME (524288)
//#define VOLUME (520192) //256*16*127
#define VOLUME (262144) //256*16*64
//#define VOLUME (131072) //256*16*32
//#define VOLUME (65536)


typedef struct{

  REAL __attribute__((aligned(VWIDTH))) re[VOLUME];
  REAL __attribute__((aligned(VWIDTH))) im[VOLUME];

} complex_vec;


typedef struct {complex_vec mat[SU3MAT_SIZE];} su3mat; 
typedef struct {complex_vec vec[SU3MAT_SIZE];} su3vec; 




// some smaller arrays of matricies for initialization

#define SMALL 10

typedef struct{

  REAL __attribute__((aligned(VWIDTH))) re[SMALL];
  REAL __attribute__((aligned(VWIDTH))) im[SMALL];

} complex_small_vec;

typedef struct {  complex_small_vec mat[SU3MAT_FULLSIZE];} sm_su3mat; 


// refer to specific matrix elements in a way  that is easy on the eye
// These are fixed, regardless of 2- or 3-column format
#define SU3_00 (0)
#define SU3_01 (1)
#define SU3_02 (2)

#define SU3_10 (3)
#define SU3_11 (4)
#define SU3_12 (5)

#define SU3_20 (6)
#define SU3_21 (7)
#define SU3_22 (8)



//#define SPLITLOOP  }for(indx=lo; indx<hi ; indx++){
#define SPLITLOOP //

 
